<script setup lang="ts">
import { useDeliveryStore } from '@/stores/delivery'
import { useOrderStore } from '@/stores/order'
import { useUserStore } from '@/stores/user'
import { onMounted } from 'vue'
import DeliveryDialogView from './DeliveryDialogView.vue'

const deliveryStore = useDeliveryStore()
const userStore = useUserStore()
const orderStore = useOrderStore()
const formatDate = (createdDate: string) => {
  const date = new Date(createdDate)
  const day = date.getDate().toString().padStart(2, '0') // Add leading zero if single digit
  const month = (date.getMonth() + 1).toString().padStart(2, '0') // Get month with leading zero
  const year = date.getFullYear()
  return `${year}-${month}-${day}`
}

onMounted(() => {
  deliveryStore.getDeliverys()
  userStore.getUserById()
  orderStore.getOrderById()
})
</script>

<template>
  <DeliveryDialogView></DeliveryDialogView>
  <v-card theme="light" height="919" outlined="false">
    <v-row class="mt-5">
      <v-col cols="5"><span class="fontTitle ml-14">Nova-consoler</span></v-col>
      <v-col></v-col>
      <v-col cols="2">
        <v-btn class="font">ชื่อผู้ใช้ : บีมเองจ้า</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="5"><span class="fontTitle ml-14">การจัดส่ง</span></v-col>
      <v-col> </v-col>
      <v-col></v-col>
    </v-row>
    <v-row class="mt-2">
      <v-col></v-col>
      <v-col>
        <v-card
          theme="light"
          height="600"
          width="1800"
          style="border: 1px solid rgba(0, 0, 0, 0.1); overflow-y: auto"
        >
          <v-table style="font-family: Arial, Helvetica, sans-serif">
            <thead>
              <tr style="background-color: #54a4ee; color: #f1f1f1">
                <th style="color: white">เลขคำสั่งซื้อ</th>
                <th style="color: white">ชื่อผู้ซื้อ</th>
                <th style="color: white">ยอดรวม</th>
                <th style="color: white">วันที่สั่งซื้อสินค้า</th>
                <th style="color: white">สถานะการจัดส่ง</th>
                <th style="color: white"></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in deliveryStore.delivery" :key="item.id">
                <td>{{ item.id }}</td>
                <td>{{ item.user!.name }}</td>
                <td>{{ item.order!.totalPrice.toLocaleString() }}</td>
                <td>{{ formatDate(item.order!.createdDate) }}</td>
                <td>{{ item.deliverystatus?.name }}</td>
                <td>
                  <v-btn @click="deliveryStore.updateDelivery(item)">
                    <v-icon left>mdi-eye</v-icon>
                    <span style="margin-left: 8px">ดูรายละเอียด</span>
                  </v-btn>
                </td>
              </tr>
            </tbody>
          </v-table>
        </v-card>
      </v-col>
      <v-col></v-col>
    </v-row>
    <v-row>
      <v-col cols="3" class="ml-13 mt-4">
        <v-btn to="/management" class="font"> <v-icon>mdi-arrow-left</v-icon> ย้อนกลับ</v-btn>
        <v-btn to="/" class="font ml-5"><v-icon>mdi-home</v-icon> กลับหน้าหลัก</v-btn>
      </v-col>
      <v-col cols="5"> </v-col>
      <v-col> </v-col>
    </v-row>
  </v-card>
</template>

<style scoped>
.custom-width {
  width: 500px;
}

.fontTitle {
  text-align-last: center;
  font-family: fantasy;
  font-size: 35px;
  color: black;
}

.fontbtn {
  text-align-last: center;
  font-family: fantasy;
  font-size: 30px;
  color: black;
}

.font {
  text-align-last: center;
  font-family: fantasy;
  font-size: 18px;
  color: black;
}
</style>
